unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    procedure Open1Click(Sender: TObject);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure ScrollBar2Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;


var
  Form1: TForm1;

  Temp :TBitmap;
implementation

uses
 EffectBass;

{$R *.DFM}

//-----------------------------------------------------------------------------
// ֐    EffectShift
// pr      C[WVtg
// 
//             hBMP             ...]TBitmap̃nh
//             nWidth           ...0`Width܂
//             nHeight          ...0`Height܂
//߂l@
//             rbg}bṽnh
// -----------------------------------------------------------------------------
function EffectShift(hBMP:HBitmap;nWidth,nHeight: integer):HBitmap;
var
  Row,Col,hoge,foo : Integer;
  SrcRow,DestRow   : pRGBArray;
  _Height,_Width   : integer;
  SrcBitmap,DestBitmap : TBitmap;
begin
 SrcBitmap   :=TBitmap.Create;
 DestBitmap  :=TBitmap.Create;
 SrcBitmap.Handle  :=hBMP;
 //͈̓`FbN
 if (nWidth>SrcBitmap.Width)  or (nHeight>SrcBitmap.Height) then
 begin
    Result :=SrcBitmap.ReleaseHandle;
    SrcBitmap.Free ;
    DestBitmap.Free;
    Exit;
 end;

 Set24bit(SrcBitmap,DestBitmap);
 _Height := SrcBitmap.height-1;
 _Width  := SrcBitmap.width-1;
 hoge:=nWidth;  foo:=nHeight;
try
   For Row := 0 To _Height   do
   begin
       SrcRow:=SrcBitmap.ScanLine[Row];
       if foo>_Height then foo:=0;
       DestRow:=DestBitmap.ScanLine[foo];

        For Col := 0 To _Width do
        begin
             if (hoge> _Width) then hoge:=0;
             DestRow[hoge].rgbtBlue:=SrcRow[Col].rgbtBlue;
             DestRow[hoge].rgbtGreen:= SrcRow[Col].rgbtGreen;
             DestRow[hoge].rgbtRed:=SrcRow[Col].rgbtRed;
             inc(hoge);
       end;
      inc(foo);
    end;
  Result :=DestBitmap.ReleaseHandle;
except
     Result :=SrcBitmap.ReleaseHandle;
end;
  SrcBitmap.Free ;
  DestBitmap.Free;
end;

/////////
procedure TForm1.Open1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
 begin
   Temp.LoadFromFIle(OpenDialog1.FIlename);
   Image1.PIcture.Bitmap.Assign(Temp);
   ScrollBar1.Max:=Image1.Width;
   ScrollBar2.Max:=Image1.Height;
   ScrollBar1.Enabled :=true;
   ScrollBar2.Enabled :=true;
 end;
end;

////////
procedure TForm1.ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
Var
 BMP: TBitmap;
begin
  if not (ScrollCode = scTrack) then
  begin
    BMP:=TBitmap.Create;
    BMP.Assign(Temp);
    Image1.Picture.bitmap.Handle:= EffectShift(BMP.ReleaseHandle,ScrollBar1.POsition,ScrollBar2.POsition);
    BMP.Free;
  end;
end;

////////
procedure TForm1.ScrollBar2Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
Var
 BMP: TBitmap;
begin
  if not (ScrollCode = scTrack) then
  begin
    BMP:=TBitmap.Create;
    BMP.Assign(Temp);
    Image1.Picture.bitmap.Handle:= EffectShift(BMP.ReleaseHandle,ScrollBar1.POsition,ScrollBar2.POsition);
    BMP.Free;
  end;
end;

/////////
procedure TForm1.FormCreate(Sender: TObject);
begin
 Temp:=TBitmap.Create;
end;

/////////
procedure TForm1.FormDestroy(Sender: TObject);
begin
 Temp.free;
end;

end.
